/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/

//{TvvOł́AlTXDSPCugpĂ܂
//{Tvrhۂɂ́A
//vWFNgtH_ȉ
//(RX65_SOUND_EFFECTOR_FFT\lib\dsplib-rxv2)
//tH_ɁAlTXWeb_E[h\ȃlTXDSPCu(an-r01an4359jj0100-rx-dsplib)Ɋ܂܂
//dsplib-rxv2 ȉ̃t@CRs[Ă
//gpĂt@C͈ȉł
//r_dsp_typedefs.h
//r_dsp_types.h
//r_dsp_transform.h
//RX_DSP_FPU_LE_Check.lib
//iRXv2ALittleEndian, FPUgpj

//INBUF_UNIT_SIZE  512 (=FFT_SAMPLING_DATA_NUM /2) ɐݒ肵Ăisound_effector_userdef.hj


//x[XƂĂvOF
//uTEhvO~Ovؒj
// chapter7 ex7_4.c
//@{R[_
//@ch0:synth, ch1:vocal

//#include "typedefine.h"
#include <machine.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mathf.h>
#include <complex.h>
#include "sound_effector.h"
#include "r_dsp_typedefs.h"
#include "r_dsp_types.h"
#include "r_dsp_transform.h"

//njOgp
#define USE_HANNING_WINDOW

//FFT̃TvO
#define FFT_SAMPLING_DATA_NUM (1024)


#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

void main(void)
{

	unsigned long prev_inbuf_wp;
	
	long inbuf_index;
	
	pcm_data pcm_tmp;
	
	int n, k, offset;
	int band, number_of_band, band_width;

	double a;
	
	float data_tmp;

	//f[^obt@staticŊmۂ
	//staticɂȂꍇ́A[UX^bNɊmۂ邽߁AX^bNTCY0x10000xKv܂
	
	static float fft_input_ch0[FFT_SAMPLING_DATA_NUM];							//time-domain, FFT̓f[^
	static float fft_input_ch1[FFT_SAMPLING_DATA_NUM];

	static float prev_output_data[FFT_SAMPLING_DATA_NUM/2];						//1OIFFT
	
	static cplxf32_t fft_output_ch0[FFT_SAMPLING_DATA_NUM/2];					//frequency-domain, FFTo̓f[^
	static cplxf32_t fft_output_ch1[FFT_SAMPLING_DATA_NUM/2];
	
	static cplxf32_t ifft_input[FFT_SAMPLING_DATA_NUM/2];						//frequency-domain, IFFT̓f[^
	static float ifft_output[FFT_SAMPLING_DATA_NUM];							//time-domain, IFFTo̓f[^
	
	static float fft_output_mag_ch1[FFT_SAMPLING_DATA_NUM/2];					//ch1 FFTʂ̐U(sqrt(re^2+im^2))

	static vector_t vtime_ch0 = {FFT_SAMPLING_DATA_NUM, (void *)fft_input_ch0};
	static vector_t vtime_ch1 = {FFT_SAMPLING_DATA_NUM, (void *)fft_input_ch1};
	
	static vector_t vfreq_ch0 = {FFT_SAMPLING_DATA_NUM/2, (void *)fft_output_ch0};
	static vector_t vfreq_ch1 = {FFT_SAMPLING_DATA_NUM/2, (void *)fft_output_ch1};
	
	static vector_t vfreq2 = {FFT_SAMPLING_DATA_NUM/2, (void *)ifft_input};
	static vector_t vtime2 = {FFT_SAMPLING_DATA_NUM, (void *)ifft_output};
	
	static vector_t vfreq_mag_ch1 = {FFT_SAMPLING_DATA_NUM/2, (void *)fft_output_mag_ch1};

	static cplxf32_t fft_twiddles1[FFT_SAMPLING_DATA_NUM + FFT_SAMPLING_DATA_NUM/2];
	static uint32_t fft_bitrev1[240];      											//1024 point̃obt@TCY

#ifdef USE_HANNING_WINDOW
	static float window[FFT_SAMPLING_DATA_NUM];										//֐
#endif

	static cplxf32_t fft_twiddles2[FFT_SAMPLING_DATA_NUM + FFT_SAMPLING_DATA_NUM/2];
	static uint32_t fft_bitrev2[240];   											//1024 point̃obt@TCY
	
#ifdef USE_HANNING_WINDOW
	static r_dsp_fft_t h1 = {FFT_SAMPLING_DATA_NUM, 0, fft_twiddles1, fft_bitrev1, NULL, window};		//FFT ֐܂߂
#else
	static r_dsp_fft_t h1 = {FFT_SAMPLING_DATA_NUM, 0, fft_twiddles1, fft_bitrev1, NULL, NULL};			//FFT ֐gȂ
#endif

	static r_dsp_fft_t h2 = {FFT_SAMPLING_DATA_NUM, 0, fft_twiddles2, fft_bitrev2, NULL, NULL};			//IFFT
	
	r_dsp_status_t sts1 = R_DSP_STATUS_OK;			//FFT
	r_dsp_status_t sts2 = R_DSP_STATUS_OK;			//IFFT
	r_dsp_status_t sts1_ch0 = R_DSP_STATUS_OK;		//FFT
	r_dsp_status_t sts1_ch1 = R_DSP_STATUS_OK;
	r_dsp_status_t sts2_mono = R_DSP_STATUS_OK;		//IFFT
	
	/* initialize required buffer sizes for twiddles etc. */
	size_t ntwb1; // bytes for twiddle array
	size_t nbrb1; // bytes for bit-reverse table
	size_t nwkb1; // bytes for working area	
	
	size_t ntwb2; // bytes for twiddle array
	size_t nbrb2; // bytes for bit-reverse table
	size_t nwkb2; // bytes for working area	
	
	//1OIFFTʂ̏
	for(n=0; n<FFT_SAMPLING_DATA_NUM/2; n++)
	{
		prev_output_data[n] = 0;
	}

#ifdef USE_HANNING_WINDOW
	//֐` njO
	for(n = 0; n < FFT_SAMPLING_DATA_NUM; n++)	//FFT_SAMPLING_DATA_NUM͋
	{
		window[n] = 0.5 - 0.5 * cosf(2.0 * M_PI * ((float)n/(float)FFT_SAMPLING_DATA_NUM));
	}
#endif
	
	//FFT\̏
	sts1 = R_DSP_FFT_BufSize_f32cf32(&h1, &ntwb1, &nbrb1, &nwkb1);
	
	if((sizeof(fft_twiddles1) < ntwb1) || (sizeof(fft_bitrev1) < nbrb1))	//sizeof(fft_twiddles1)=12,288, ntwb1=6,144 cKv̔{mۂĂH//sizeof(fft_bitrev1)=960, nbrb1=960
	{
		while(1); /* not enough memory size */
	}
	
	sts1 = R_DSP_FFT_Init_f32cf32(&h1);
	
	//IFFT\̏
	sts2 = R_DSP_FFT_BufSize_cf32f32(&h2, &ntwb2, &nbrb2, &nwkb2);
	
	if((sizeof(fft_twiddles2) < ntwb2) || (sizeof(fft_bitrev2) < nbrb2))
	{
		while(1); /* not enough memory size */
	}
	
	sts2 = R_DSP_FFT_Init_cf32f32(&h2);
	
	band_width = 8;
	number_of_band = FFT_SAMPLING_DATA_NUM / 2 / band_width;
	
	//֐
	sound_effector_init();
	
	//Jn
	sound_effector_start();
	
	prev_inbuf_wp = 0;

	while(1)
	{
		
		if(g_sw_state == 0)
		{
			//X[
			if(prev_inbuf_wp != g_inbuf_wp)
			{
				for(n=0; n<INBUF_UNIT_SIZE; n++)
				{
					put_data(g_inbuf[prev_inbuf_wp + n]);
				}
				prev_inbuf_wp = g_inbuf_wp;
				
#ifdef DEBUG
				g_err_led_patturn = LED_OFF;
#endif
			}
		}
		else
		{
			//FFT
			if(prev_inbuf_wp != g_inbuf_wp)
			{
#ifdef DEBUG_PORT
				P27 = 1;
#endif
				
				//1 (-512)-511̃f[^, _~[
				//2 0-1023f[^
				//3 512-1535̃f[^
				//4 1024-2047̃f[^
				//512I[obvăf[^
				
				//̓f[^FFT\̓̔zϐɃRs[
				for(n=0; n<FFT_SAMPLING_DATA_NUM; n++)
				{
					//̎_ŁAinbuf_wp(=prev_inbuf_wp +(FFT_SAMPLING_DATA_NUM/2))܂ł
					//̓f[^i[ς
					//prev_inbuf_wp - (FFT_SAMPLING_DATA_NUM/2) ` prev_inbuf_wp - (FFT_SAMPLING_DATA_NUM/2) + FFT_SAMPLING_DATA_NUM
					//iprev_inbuf_wp-512 ` prev_inbuf_wp+512(=inbuf_wp) ͈̔͂̃f[^ǂݍގ͖肪Ȃ
					
					inbuf_index = prev_inbuf_wp - FFT_SAMPLING_DATA_NUM/2 + n;
					if(inbuf_index < 0) inbuf_index += INBUF_SIZE;
					else if(inbuf_index >= INBUF_SIZE) inbuf_index -= INBUF_SIZE;
					
					fft_input_ch0[n] = (float)g_inbuf[inbuf_index].ch0 / 32768.0;
					fft_input_ch1[n] = (float)g_inbuf[inbuf_index].ch1;
					
					/* vGt@VXiVocalj */
					//1TvO̐M
					inbuf_index--;
					if(inbuf_index < 0) inbuf_index += INBUF_SIZE;
					fft_input_ch1[n] -= (float)g_inbuf[inbuf_index].ch1 * 0.98;
					
					fft_input_ch1[n] /= 32768.0;
				}
				
				//FFT vtime -> vfreq, ԗ̈悩g̈ɕϊ
				sts1_ch0 = R_DSP_FFT_f32cf32(&h1, &vtime_ch0, &vfreq_ch0);
				sts1_ch1 = R_DSP_FFT_f32cf32(&h1, &vtime_ch1, &vfreq_ch1);
				
				//M
				
				//sqrt(re^2 + im^2)̌vZi^^̂ǂ炩gpj
				//R_DSP_VecCplxMag_Fast_cf32f32(&vfreq_ch1, &vfreq_mag_ch1, FFT_SAMPLING_DATA_NUM/2);	//Cu֐i^jgpisqrtgpߎvZj
				R_DSP_VecCplxMag_cf32f32(&vfreq_ch1, &vfreq_mag_ch1, FFT_SAMPLING_DATA_NUM/2);			//Cu֐i^jgp
				
				//0-511̃ohA0-7, 8-15, ..., 504-51164̃oh̎gGx[vZo
			    for(band=0; band<number_of_band; band++)	//number_of_band=64
			    {
     				offset = band_width * band;					//band_width=8
					
					a = 0.0;
					for(k=0; k<band_width; k++)
					{
						a += fft_output_mag_ch1[offset + k];
					}
					a /= band_width;
					for(k=0; k<band_width; k++)
					{
						fft_output_mag_ch1[offset + k] = a;
					}
				}
				fft_output_mag_ch1[0] = 0.0;							//fftU̍ŏ̍[Ƃ
				
				/* tB^O */
				for(k=0; k<FFT_SAMPLING_DATA_NUM/2; k++)
				{
					//ifft_input[k].re = fft_output_ch0[k].re * b_real[k] - fft_output_ch0[k].im * fft_output_ch1[k].im;	//ch1, voval̋0Ƃ
 					//ifft_input[k].im = fft_output_ch0[k].im * b_real[k] + fft_output_ch0[k].re * fft_output_ch1[k].im;	//ch1, voval̋0Ƃ
					
					ifft_input[k].re = fft_output_ch0[k].re * fft_output_mag_ch1[k];	//̉Zȗ
 					ifft_input[k].im = fft_output_ch0[k].im * fft_output_mag_ch1[k];	//̉Zȗ
				}
				
				//IFFT vfreq -> vtime2, g̈悩玞ԗ̈ɋtϊ
				sts2_mono = R_DSP_IFFT_CCS_cf32f32(&h2, &vfreq2, &vtime2);
				
				//IFFTʂ̘A
				for(n=0; n<FFT_SAMPLING_DATA_NUM/2; n++)
				{
					//O512f[^́AỎZʂƉZďo̓obt@Ɋi[
					
					data_tmp = (prev_output_data[n] + ifft_output[n]);
					
					//NbsO, mf[^ch0, ch1ɏo
					pcm_tmp = clipping_data_norm(data_tmp, data_tmp);
					
					put_data(pcm_tmp);
				}
				
				for(n=0; n<FFT_SAMPLING_DATA_NUM/2; n++)
				{
					//㔼512f[^́AϐɈꎞۑ
					prev_output_data[n] = ifft_output[n + FFT_SAMPLING_DATA_NUM/2];
				}
			
				prev_inbuf_wp = g_inbuf_wp;
				
#ifdef DEBUG_PORT
				P27 = 0;
#endif

#ifdef DEBUG
				//ErrLEDu点
				g_err_led_patturn = 0x00000001;
#endif
			}
		}

	}//while
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
